VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' clsFolder
'
' 4/15/2001
' Kenrick Mock
' kenrick@acm.org
'
' This class exposes an interface to manage a college of
' messages.  The messages are stored internally using
' a dictionary.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Compare Text
Public dictMessages As Dictionary
Public sFolderName As String

Public Sub AddMessage(sEntryID As String, sSender As String, sSubj As String, sBody As String)
    Dim cMsg As clsMessage

    If dictMessages.Exists(sEntryID) Then
        Exit Sub
    End If
    Set cMsg = New clsMessage
    cMsg.sEntryID = sEntryID
    cMsg.AddTerms sSender + " " + sSubj + " " + sBody
    dictMessages.Add sEntryID, cMsg
    
    ' Verify that the outlook category matches the actual category.  If
    ' it doesnt, change the category field to match.  The exception is if
    ' the current message is in the INBOX, then don't assign a category name.
    If sFolderName <> modGlobals.objInbox.Name Then
        If cMsg.GetOutlookCategory <> sFolderName Then
            cMsg.SetOutlookCategory sFolderName
        End If
    End If
End Sub

' Compare message class to this message and return relevance
' Uses a very simple nearest-neighbor algorithm for now,
' find the three most similar messages and average their values
' We need to try experiments with better methods, particularly
' cases where there are no good matches at all
Public Function CompareMessage(cMsg As clsMessage) As Double
    Dim cFolderMsg As clsMessage
    Dim l As Long
    Dim j As Long
    Dim sngBest(3) As Single
    Dim sngCur As Single
    
    If dictMessages.Count < 3 Then
        CompareMessage = 0
        Exit Function
    End If
    
    sngBest(1) = 0
    sngBest(2) = 0
    sngBest(3) = 0
    For l = 0 To dictMessages.Count - 1
        Set cFolderMsg = dictMessages.Items(l)
        sngCur = cMsg.CompareToMessage(cFolderMsg)
        If sngCur > sngBest(1) Then
            sngBest(1) = sngCur
        ElseIf sngCur > sngBest(2) Then
            sngBest(2) = sngCur
        ElseIf sngCur > sngBest(3) Then
            sngBest(3) = sngCur
        End If
    Next l
    CompareMessage = (sngBest(1) + sngBest(2) + sngBest(3)) / 3
End Function


Private Sub Class_Initialize()
    Set dictMessages = New Dictionary
End Sub

Private Sub Class_Terminate()
    dictMessages.RemoveAll
    Set dictMessages = Nothing
End Sub
