VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmRelated 
   Caption         =   "Similar Emails"
   ClientHeight    =   6015
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7980
   Icon            =   "frmRelated.frx":0000
   LinkTopic       =   "Form2"
   ScaleHeight     =   6015
   ScaleWidth      =   7980
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.ListView listSimilar 
      Height          =   3855
      Left            =   720
      TabIndex        =   0
      Top             =   720
      Width           =   6735
      _ExtentX        =   11880
      _ExtentY        =   6800
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      FullRowSelect   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "frmRelated"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' frmRelated
'
' 4/15/2001
' Kenrick Mock
' kenrick@acm.org
'
' This form displays related items by methodically
' scanning through every single message using a
' simple comparison function (for now).
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Option Explicit
Private LastItemClick As ListItem

Private Sub Form_Load()
    listSimilar.View = lvwReport
    listSimilar.LabelEdit = lvwManual
    listSimilar.FullRowSelect = True
    listSimilar.ColumnHeaders.Add , , "From", listSimilar.Width / 4
    listSimilar.ColumnHeaders.Add , , "Subject", listSimilar.Width / 2
    listSimilar.ColumnHeaders.Add , , "Received", listSimilar.Width / 4
    listSimilar.ColumnHeaders.Add , , "Rank"

    listSimilar.SortKey = 1
End Sub

' Finds similar messages to the currently open outlook message
Public Sub FindSimilarMessages(oMsg As Outlook.MailItem)
  Dim oItem As Object
  Dim cMsg As clsMessage
  Dim tMsg As clsMessage
  Dim l As Long
  Dim j As Long
  Dim sSender As String
  Dim sSubj As String
  Dim sBody As String
  Dim dictSimilar As Dictionary
  Dim dSimilarity As Single
  Dim f As clsFolder
  Dim vKeys As Variant
  Dim vItems As Variant

  On Error GoTo bailout
  
  Set cMsg = New clsMessage
  sSender = oMsg.SenderName
  sSubj = oMsg.Subject
  sBody = Left(oMsg.Body, MAXBODYCHARS)
  sBody = modFeatures.StripLastWord(sBody)
  cMsg.sEntryID = oMsg.EntryID
  cMsg.AddTerms sSender + " " + sSubj + " " + sBody
  
  ' Set a message indicating we're processing
  AddListItem "", "foo", "Please Wait, searching for similar messages...", "", 1
  
  ' Scan through all our messages, compare to it, store in a dictionary
  Set dictSimilar = New Dictionary
  For l = 0 To modGlobals.dictFolders.Count - 1
        Set f = modGlobals.dictFolders.Items(l)
        For j = 0 To f.dictMessages.Count - 1
            Set tMsg = f.dictMessages.Items(j)
            dSimilarity = tMsg.CompareToMessage(cMsg)
            dictSimilar.Add tMsg.sEntryID, dSimilarity
            DoEvents
        Next j
  Next l
  
  ' Go through the top 50 items and add them to the listbox
  vKeys = dictSimilar.Keys
  vItems = dictSimilar.Items
  modSorters.sortFeatures vKeys, vItems, 0, UBound(vKeys) - 1
  listSimilar.ListItems.Clear
  j = dictSimilar.Count
  If j > 50 Then
      j = 50
  End If
  For l = 0 To j - 1
    Set oMsg = oNS.GetItemFromID(CStr(vKeys(l)))
    AddListItem oMsg.SenderName, oMsg.EntryID, oMsg.Subject, oMsg.ReceivedTime, l + 1
  Next l
  
  Set dictSimilar = Nothing
  Set cMsg = Nothing
  Exit Sub
bailout:
  MsgBox "Please open a message before invoking this function.", vbExclamation
  On Error Resume Next
End Sub

Private Sub AddListItem(sFrom As String, sEntryID As String, sSubj As String, sRecv As String, lRank As Long)
    Dim li As ListItem
    
    Set li = listSimilar.ListItems.Add(, sEntryID, sFrom)
    li.ListSubItems.Add , , sSubj
    li.ListSubItems.Add , , sRecv
    li.ListSubItems.Add , , CStr(Format(lRank, "00"))
End Sub

Private Sub Form_Resize()
    listSimilar.Left = 1
    listSimilar.Top = 1
    If frmRelated.Width > 130 Then
        listSimilar.Width = frmRelated.Width - 130
    End If
    If frmRelated.Height > 370 Then
        listSimilar.Height = frmRelated.Height - 370
    End If
End Sub

' Sort the columns based on the one clicked
Private Sub listSimilar_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    listSimilar.Sorted = True
    listSimilar.SortKey = ColumnHeader.Index - 1
End Sub

' Open up the message double-clicked upon using outlook
Private Sub listSimilar_DblClick()
  Dim oMsg As Outlook.MailItem
  Set oMsg = oNS.GetItemFromID(LastItemClick.Key)
  oMsg.Display
End Sub

' remember the last item clicked
Private Sub listSimilar_ItemClick(ByVal Item As MSComctlLib.ListItem)
    Set LastItemClick = Item
End Sub


