Attribute VB_Name = "modStopList"
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' modStopList
'
' 4/15/2001
' Kenrick Mock
' kenrick@acm.org
'
' This module contains stop list words
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit
Option Compare Text
Private dictStop As Dictionary
Private vIDArray As Variant
Private vStrArray As Variant
Dim stopList As Variant

Public Sub LoadStopList()
    Dim l As Long
    
    vIDArray = Empty
    stopList = Array("about", "above", "across", "after", "again", "against", "all", "almost", "alone", "along", "already", "also", "although", "always", "among", "an", "and", "another", "any", "anybody", "anyone", "anything", "anywhere", "are", _
                     "area", "areas", "around", "as", "ask", "asked", "asking", "asks", "at", "away", "back", "backed", "backing", "backs", "be", "because", "become", "becomes", "became", "been", "before", "began", "behind", "being", "beings", "best", "better", "between", "big", "both", "but", "by", "came", "can", "cannot", "case", "cases", "certain", "certainly", "clear", "clearly", "come", "could", _
                     "did", "differ", "different", "differently", "do", "does", "done", "down", "downed", "downing", "downs", "during", "each", "early", "either", "end", "ended", "ending", "ends", "enough", "even", "evenly", "ever", "every", "everybody", "everyone", "everything", "everywhere", "face", "faces", "fact", "facts", "far", "felt", "few", "find", "finds", "first", "for", "four", "from", "full", _
                     "fully", "further", "furthered", "furthering", "furthers", "gave", "general", "generally", "get", "gets", "give", "given", "gives", "go", "going", "good", "goods", "got", "great", "greater", "greatest", "group", "grouped", "grouping", "groups", "had", "has", "have", "having", "he", "her", "herself", "here", "high", "higher", "highest", "him", "himself", "his", "how", "however", "if", _
                     "important", "in", "interest", "interested", "interesting", "interests", "into", "is", "it", "its", "itself", "just", "keep", "keeps", "kind", "knew", "know", "known", "knows", "large", "largely", "last", "later", "latest", "least", "less", "let", "lets", "like", "likely", "long", "longer", "longest", "made", "make", "making", "man", "many", "may", "me", "member", "members", "men", _
                     "might", "more", "most", "mostly", "mr", "mrs", "much", "must", "my", "myself", "necessary", "need", "needed", "needing", "needs", "never", "new", "newer", "newest", "next", "no", "non", "not", "nobody", "noone", "nothing", "now", "nowhere", "number", "numbered", "numbering", "numbers", "of", "off", "often", "old", "older", "oldest", "on", "once", "one", "only", "open", "opened", _
                     "opening", "opens", "or", "order", "ordered", "ordering", "orders", "other", "others", "our", "out", "over", "part", "parted", "parting", "parts", "per", "perhaps", "place", "places", "point", "pointed", "pointing", "points", "possible", "present", "presented", "presenting", "presents", "problem", "problems", "put", "puts", "quite", "rather", "really", "right", "room", "rooms", "said", _
                     "same", "saw", "say", "says", "second", "seconds", "see", "sees", "seem", "seemed", "seeming", "seems", "several", "shall", "she", "should", "show", "showed", "showing", "shows", "side", "sides", "since", "small", "smaller", "smallest", "so", "some", "somebody", "someone", "something", "somewhere", "state", "states", "still", "such", "sure", "take", "taken", "than", "that", "the", "their", _
                     "them", "then", "there", "therefore", "these", "they", "thing", "things", "think", "thinks", "this", "those", "though", "thought", "thoughts", "three", "through", "thus", "to", "today", "together", "too", "took", "toward", "turn", "turned", "turning", "turns", "two", "under", "until", "up", "upon", "us", "use", "uses", "used", "very", "want", "wanted", "wanting", "wants", "was", "way", _
                     "ways", "we", "well", "wells", "went", "were", "what", "when", "where", "whether", "which", "while", "who", "whole", "whose", "why", "will", "with", "within", "without", "work", "worked", "working", "works", "would", "year", "years", "yet", "you", "young", "younger", "youngest", "your", "yours")
    Set dictStop = New Dictionary
    modFeatures.strHash.HashStringToID stopList, vIDArray
    For l = 0 To UBound(vIDArray)
        dictStop.Add vIDArray(l), 1
    Next l
End Sub


Public Function IsWordInStopList(sWord As String) As Boolean
    ' Make anything <=2 chars be in the stop list by default
    If Len(sWord) <= 2 Then
        IsWordInStopList = True
    Else
        vIDArray = Empty
        vStrArray = Empty
        ReDim vStrArray(0)
        vStrArray(0) = sWord
        modFeatures.strHash.HashStringToID vStrArray, vIDArray
        IsWordInStopList = dictStop.Exists(vIDArray(0))
    End If
End Function

Public Function IsIDInStopList(lID As Long) As Boolean
    IsIDInStopList = dictStop.Exists(lID)
End Function

' Given an array of IDs, remove the stop terms and return as an array
Public Sub RemoveStopWordIDs(lArrayIn() As Long, ByRef lArrayOut() As Long)
    Dim lIn As Long
    Dim lOut As Long

    ReDim lArrayOut(UBound(lArrayIn))
    lOut = 0
    For lIn = 0 To UBound(lArrayIn)
        If IsIDInStopList(lArrayIn(lIn)) = False Then
            lArrayOut(lOut) = lArrayIn(lIn)
            lOut = lOut + 1
        End If
    Next lIn
    If lOut > 0 Then
        ReDim Preserve lArrayOut(lOut - 1)
    End If
End Sub

Public Sub Shutdown()
    Set dictStop = Nothing
End Sub
